﻿using C1.Xaml.Chart;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.System.Threading;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace ChartAsyncLoad
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }

        private async void Button_Click(object sender, RoutedEventArgs e)
        {
            progressRing.IsActive = true;
            await LoadChartAsync();

            // example 2: with ThreadPool
            //await ThreadPool.RunAsync(delegate { LoadChart(); });

            progressRing.IsActive = false;
        }

        public IAsyncAction LoadChartAsync()
        {
            return Task.Run(() =>
            {
                Dispatcher.RunAsync(Windows.UI.Core.CoreDispatcherPriority.Normal, () =>
                {

                    DataSeries ds = new DataSeries();
                    Random rnd = new Random();
                    ds.Values = new DoubleCollection();
                    for (int i = 0; i < 1000; i++)
                    {
                        ds.Values.Add(rnd.Next(0, 100));
                    }
                    c1Chart1.Data.Children.Add(ds);
                });
            }).AsAsyncAction();
        } 

        //// example 2: with ThreadPool
        //public async void LoadChart()
        //{
        //    await Dispatcher.RunAsync(Windows.UI.Core.CoreDispatcherPriority.Normal, () =>
        //            {
        //                // do stuff to your UI
        //                DataSeries ds = new DataSeries();
        //                Random rnd = new Random();
        //                ds.Values = new DoubleCollection();
        //                for (int i = 0; i < 1000; i++)
        //                {
        //                    ds.Values.Add(rnd.Next(0, 100));
        //                }
        //                c1Chart1.Data.Children.Add(ds);
        //            });
        //}

    }
}
